
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

/*
 * Created on 24.04.2005
 *
 */

/**
 * @author Marc Breisinger
 *  
 */
public class Controller implements ActionListener {

	private Model model;

	private View view;

	public Controller(Model m, View v) {
		model = m;
		view = v;
		JButton[] buttons = view.getButtons();
		for (int i = 0; i < buttons.length; i++) {
			buttons[i].addActionListener(this);
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals("Delete")) {
			model.deleteCharacter();
		} else if (e.getActionCommand().equals("Clear")) {
			model.reset();
		} else if (e.getActionCommand().equals("Exit")) {
			view.getFrame().dispose();
		} else {
			model.addCharacter(e.getActionCommand().charAt(0));
		}
	}
}