/*
 * Created on 19.04.2005
 *
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
/**
 * @author Marc Breisinger
 *
 */
public class Main {
	public static void main(String[] args) {
		
		Model model = new Model();
		
		JFrame dialog = createDialog(model);
		dialog.pack();
		dialog.setVisible(true);
	}
	
	/*A dialog for optional modification.
	 *Not demanded.
	 */
	public static JFrame createDialog(Model m){
		
		final Model model = m;
		//a dialog box that asks, how to build the keyboard
		JFrame dialog  = new JFrame("Virtual Keyboard Setup");
		dialog.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		JPanel ascii = new JPanel();
		JPanel chars = new JPanel();
		JPanel buttons = new JPanel();
		
		//the buttons must be declared final to be accessable by 
		//the ActionListener, which is an inner class
		final JRadioButton asciiRadio = new JRadioButton("Create By Ascii");
		final JRadioButton charsRadio = new JRadioButton("Create By Characters");
		ButtonGroup radios = new ButtonGroup();
		radios.add(asciiRadio);
		radios.add(charsRadio);
		charsRadio.setSelected(true);
		
		final JTextField ascii1 = new JTextField(3);
		final JTextField ascii2 = new JTextField(3);
		
		ascii1.setText("65");
		ascii2.setText("122");
		
		final JTextField chars1 = new JTextField(2);
		final JTextField chars2 = new JTextField(2);
		
		chars1.setText("A");
		chars2.setText("z");
		
		JLabel to1 = new JLabel("to");
		JLabel to2 = new JLabel("to");
		
		ascii.add(asciiRadio);
		ascii.add(ascii1);
		ascii.add(to1);
		ascii.add(ascii2);
		
		chars.add(charsRadio);
		chars.add(chars1);
		chars.add(to2);
		chars.add(chars2);
		
		
		JButton create = new JButton("Create Keyboard");
		JButton exit = new JButton("Exit");
		
		create.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				View view;
				if(asciiRadio.isSelected()){
					int a1 = Integer.parseInt(ascii1.getText());
					int a2 = Integer.parseInt(ascii2.getText());
					if(a1 > a2){
						int mem = a1;
						a1 = a2;
						a2 = mem;
					}
				view = new View(a1,a2,model);
				}
				else {
							int c1 = (int)chars1.getText().charAt(0);
							int c2 = (int)chars2.getText().charAt(0);
							if(c1 > c2){
								int mem = c1;
								c1 = c2;
								c2 = mem;
							}
							view = new View(c1, c2, model);
				}
				Controller c = new Controller(model, view);
				
			}});
		exit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		
		buttons.add(create);
		buttons.add(exit);
		Container cp = dialog.getContentPane();
		cp.setLayout(new BorderLayout());
		cp.add(ascii, BorderLayout.NORTH);
		cp.add(chars, BorderLayout.CENTER);
		cp.add(buttons, BorderLayout.SOUTH);
		return dialog;
	}
}
