/*
 * Created on 19.04.2005
 */
import javax.swing.*;
import java.awt.*;
import java.util.Observable;
import java.util.Observer;
/**
 * @author Marc Breisinger
 */
public class View implements Observer{
	
	private JButton[] buttons;
	private JTextField output;
	private JFrame frame;
	private int height;
	private int width;
	private Container cp;
	private Model model;
	
	public View(int start, int end, Model m){
		model = m;
		
		frame = new JFrame();
		frame.setTitle("My Keyboard");
		
		cp = frame.getContentPane();
	
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		init(start, end);
		model.addObserver(this);
		frame.setVisible(true);
	}
	
	private void init(int start, int end){
		//System.out.println("Creating Keyboard from "+String.valueOf((char)start)+" to "+String.valueOf((char)end));
		int nrButtons = end-start+1;
		//computing / setting layout parameters
		
		cp.setLayout(new GridLayout(0,1));
		int nrOfButtonsInOneRow = 12;
		int counter = nrOfButtonsInOneRow;
		int rows = 1+(nrButtons / nrOfButtonsInOneRow);
		
		JPanel outPanel = new JPanel();
		JLabel outLabel = new JLabel("Output:");
		JButton del = new JButton("Delete");
		JButton clear = new JButton("Clear");
		JButton exit = new JButton("Exit");
		output = new JTextField(30);
		output.setEditable(false);
		output.setText(model.getText());
		outPanel.add(outLabel);
		outPanel.add(output);
		outPanel.add(del);
		outPanel.add(clear);
		outPanel.add(exit);
		cp.add(outPanel);
		
		JPanel row = new JPanel();
		buttons = new JButton[nrButtons+3]; //three more buttons exit, del and clear
		//create one button for every char, hang it in a row 
		//and put it into the array for the controller
		for (int i = 0; i < nrButtons; i++){
			buttons[i] = new JButton(String.valueOf((char)(i+start)));
			row.add(buttons[i]);
			counter--;
			//row filled or last button
			if(counter == 0 || (i+1) == nrButtons){				
				cp.add(row);
				counter = nrOfButtonsInOneRow;
				row = new JPanel();
			}
		
		}
		buttons[nrButtons] = del;
		buttons[nrButtons+1] = clear;
		buttons[nrButtons+2] = exit;
		frame.pack();
	}
	/**
	 * @return Returns the buttons.
	 */
	public JButton[] getButtons() {
		return buttons;
	}

	public void update(Observable o, Object arg) {
		output.setText(model.getText());		
	}
	/**
	 * @return Returns the frame.
	 */
	public JFrame getFrame() {
		return frame;
	}
}
